
var DragInfoGraphic = null;

(function($){
  
  DragInfoGraphic = Class.extend({
      
     init: function(options) {
		 var self = this;	    
		 this.defaults = {
		     canvas: '#dragGraphicCanvas',
		     button: '#next',
		     ajaxUrl: '',
		     gotoUrl: '',
		     id: 0,
		     space: 10,
		     zones: [
		        {node:"#zone1", className:"leftTop", label: 'Haushalt', img:'', color: '#00abab', width:305, height:137, top:10, left:10, padding:'28px 10px 10px 10px'},
			 	{node:"#zone2", className:"rightTop", label: 'Freizeit', img:'', color: '#1edfdc', width:305, height:137, top:10, left:345, padding:'28px 10px 10px 10px'},
			 	{node:"#zone3", className:"leftBottom", label: 'Bildung/Beruf', img:'', color: '#1edfdc', width:305, height:137, top:195, left:10, padding:'28px 10px 10px 10px'},
			 	{node:"#zone4", className:"rightBottom", label: 'Luxus', img:'', color: '#00abab', width:305, height:137, top:195, left:345, padding:'28px 10px 10px 10px'}
		     ],
		     statusNode: '#zonebudget',
		     iconBar: '#bar',
		     icons: [
				 {glyph: 'print', info: 'Kopfhörer'},
				 {glyph: 'fire', info: 'Computer'},
				 {glyph: 'magnet', info: 'Sparen'},
				 {glyph: 'parents', info: 'Flugzeug'},
				 {glyph: 'binoculars', info: 'Sounds'},
				 {glyph: 'road', info: 'Spielen'},
				 {glyph: 'search', info: 'Kopfhörer'},
				 {glyph: 'cars', info: 'Computer'},
				 {glyph: 'notes', info: 'Sparen'},
				 {glyph: 'wifi_alt', info: 'Flugzeug'},
				 {glyph: 'old_man', info: 'Sounds'},
				 {glyph: 'group', info: 'Spielen'}
		     ],
		     iconViewLength: 6
		 };
		 
		 this.opt = $.extend(this.defaults, options);
		 this.opt.canvas = $(this.opt.canvas);
		 this.opt.button = $(this.opt.button);
		 this.opt.statusNode = $(this.opt.statusNode);
		 this.status = '';
		 this.opt.iconViewLength = parseInt(self.opt.iconViewLength);
		 
		 
		 
		 this.opt.iconBar = $(this.opt.iconBar);
		 this.flipView = null;
		 this.iconBarIndex = 1;
		 
		 this.itemStack = [];
		 this.itemStackIndex = 0;
		 
		 this.price = 0;
		 
		 this.createViews();
		 this.initDrags();
		 
		 this.loadSavings(); 
		 
		 this.opt.button.bind('click', function() {
		     self.openDialog();
		     self.save();
		 } );
	 
     },

     createViews: function() {
		 var self = this;
		 
		 this.opt.canvas.append( 
		    '<div id="g_dialog" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">'+
                    '   <div class="modal-dialog">'+
                    '       <div class="modal-content">'+
		    '           <div class="modal-header">'+
		    '               <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>'+
		    '               <h3 id="g_header">Modal header</h3>'+
		    '           </div>'+
		    '           <div id="g_cont" class="modal-body"></div>'+
		    '           <div class="modal-footer">'+
		    '               <button class="btn" data-dismiss="modal" aria-hidden="true">Ok</button>'+
		    '           </div>'+
                    '       </div>'+
                    '   </div>'+
		    '</div>' );
			 
		 for(var i=0; i < this.opt.zones.length; i++) {
		     this.opt.zones[i].node = $(this.opt.zones[i].node);
		     this.opt.zones[i].node
			 .css({
			     backgroundColor: self.opt.zones[i].color,
			     width: self.opt.zones[i].width,
			     height: self.opt.zones[i].height,
			     position: 'absolute',
			     top: self.opt.zones[i].top,
			     left: self.opt.zones[i].left,
			     padding: self.opt.zones[i].padding
			 })
			 .addClass(self.opt.zones[i].className);
			 
		     this.opt.zones[i].node.append('<div class="zLabel">'+this.opt.zones[i].label+'</div>');
		 }
	
		 var drag = $('<div id="i_drag"></div>')
		 
		 
		 for(var i=0; i < this.opt.icons.length; i++) {
		     var icon = $(  '<div class="icon inbar" title="'+this.opt.icons[i].info+'">'+
				    '<img class="img-responsive" src="./img/icons/'+this.opt.icons[i].glyph+'" />'+
				    '</div>');			
		     drag.append(icon);
		 }
	
		 this.opt.iconBar.append(drag);
		
		 this.flipView = new FlipView({
			containerId: '#i_drag',
			itemClass: ".icon",
			spaceBetweenItems: 0,
			itemWidth: 147,
			itemHeight: 80,
			dragTolerance: 60,
			animationType: 'linear',
			dragDisable: true,
			duration: 200
		 });
	
		 this.opt.canvas.find('.goLeft').bind('click', function() {
		     if(self.iconBarIndex >= 2) {
			self.flipView.slideToLeft();
			self.iconBarIndex--;
		     }
		 });
		 
		 this.opt.canvas.find('.goRight').bind('click', function() {
		     if(self.iconBarIndex <= ( self.opt.icons.length - self.opt.iconViewLength) )
			self.flipView.slideToRight();	  
			self.iconBarIndex ++;
		 });
		 
		 $('.icon').tooltip({title: 'title'});
     },
     
     initDrags: function() {
		 var self = this;
		 
		 this.opt.iconBar.find('.icon')
		 .draggable({
		    snap: '.zone',
		    snapMode: "inner",
		    revert: 'invalid',
		    helper: "clone",
		    containment: 'body',
		    appendTo: this.opt.canvas,
		    start: function (event, ui) {            	
	            },
	            drag: function (event, ui) {		
	            },
	            stop: function (event, ui) {		
	            }
		});
		
		this.opt.canvas.find('.zone')
		.droppable({
		    accept: ".icon",
		    drop: function( event, ui ) {
			var node = ui.draggable;
			var item = null;
			var isnew = false;
			
			if( $(node).hasClass('inbar') ) {
			    isnew = true;
			    node = node
				    .clone()
				    .removeClass('inbar')
				    .addClass('inzone');
			    item = self.createItem(node);
			    item.showForm();		    
			}else {
			    item = self.getItem(node.attr('item_id'));
			}
			
			node.css({
			    position: 'relative',
			    top: 0,
			    left: 0
			});
			
			
			if( $(this).find('.icon').length >= 10) {
			    if($(node).parent().attr('id') == $(this).attr('id')) {
				$(this).append( node );
			    }else if(isnew) {
				self.removeItem(item.opt.id);
			    }
			}else {
			    $(this).append( node );
			}		
			
			self.initZoneDrags();
		    }
		});	
     },
     
     openDialog: function() {
		 var self = this;
		 
		 var zones = [];
		 for(var i=0; i < this.opt.zones.length; i++) {
		     zones.push( {name:this.opt.zones[i].label, price:0});
		     this.opt.zones[i].node.find('.icon').each(function(y, elem) {
			 var item = self.getItem( $(elem).attr('item_id') );
			 zones[i].price += item.giveMonthPrice();
		     }); 
		 }
		 
			 
		 var img = '';
		 var label = "";
		 var price = 0;
		 var priceAll = 0;
		 for(var i=0; i < zones.length; i++) {
			 priceAll += zones[i].price;			 
		     if(price < zones[i].price) {
				 price = zones[i].price;
				 label = zones[i].name;
				 img = this.opt.zones[i].img;
		     }
		 }	 
		 
		 this.status = label+'|'+price;		 
		 var cont = 'Deine monatlichen Ausgaben betragen im Schnitt ca. '+priceAll+' €.<br/><br/>';
		 cont += 'Mit '+price+' € fließt das meiste deiner Kohle in den Bereich '+label;
		 cont += '<img src="'+img+'" style="padding:10px 0px;"/>';
		 cont += 'Tipp:<br/>Prüfe regelmäßig, ob deine Ausgaben auch deinem Budget entsprechen. Wenn du nicht weißt, an welchen Stellen du zu viel ausgibst oder wo du ohne Aufwand etwas einsparen könntest, kann z.B. ein Haushaltsbuch helfen, in das du alle deine Ausgaben  einträgst. So behältst du immer einen Überblick und weißt, wann dein Budget erschöpft ist.';

		 $( "#g_header" ).html('Auswertung');
		 $( "#g_cont" ).html(cont);
		 $( "#g_dialog" ).modal('show');
		 
		 $('#g_dialog').on('hidden', function () {
			//window.location.href = self.opt.gotoUrl;
		 });
		 $( "#g_dialog" ).modal('show');
     },
     
     
          
     
     disableIconBar: function() {
    	 this.opt.iconBar.find('.icon').draggable("disable");
     },
     
     enableIconBar: function() {
    	 this.opt.iconBar.find('.icon').draggable("enable");
     },
     
     initZoneDrags: function() {
		 var self = this;
		 
		 this.opt.canvas.find('.zone .icon')
		 .css('-ms-touch-action', 'none')
		 .draggable({
			 snap: '.zone',
			 snapMode: "both",
			 revert: function(event) {
				 if(event == false) {
					 self.removeItem($(this).attr('item_id'));		    
				 }
			 },
			 appendTo: this.opt.canvas,
			 start: function (event, ui) {
				 var item = self.getItem( $(ui.helper).attr("item_id") );
				 try {$(ui.helper).tooltip( "destroy" );}catch(e){}
             },
             drag: function (event, ui) {},
             stop: function (event, ui) {
            	 var item = self.getItem( $(ui.helper).attr("item_id") );
            	 setTimeout(function() {
            		 try {item.inDrag = false;}catch(e){}
            	 },100);
            }
		 });
     },
     
     createItem: function(node, values) {
		 this.itemStackIndex++;
		 
		 if(values) {
		     values = jQuery.extend({
			 canvas: node,
			 id: this.itemStackIndex,
			 control: this		 
		     }, values);
		 }else {
		     values = {
			 canvas: node,
			 id: this.itemStackIndex,
			 control: this
		     }
		 }
		 
		 var item = new DragInfoItem(values);
		 this.itemStack.push(item);
		 this.disableIconBar();
		 return item;
     },
     
     getItem: function(id) {
		 var self = this;	 
		 for(var i=0; i < self.itemStack.length; i++) {
		     if(self.itemStack[i].opt.id == id) {
			 return self.itemStack[i];
		     }
		 }
     },
     
     removeItem: function(id) {
		 var self = this;
		 var n = [];
		 for(var i=0; i < self.itemStack.length; i++) {
		     if(self.itemStack[i].opt.id == id) {
			 self.itemStack[i].destroy();
		     }else {
			 n.push(self.itemStack[i]);
		     }
		 }
		 
		 self.itemStack = n;
		 self.checkItems();
     },
     
     checkItems: function() {
		 var self = this;	
		 
		 //self.updateStatus();
		 for(var i=0; i < self.itemStack.length; i++) {
		     if(self.itemStack[i].formValid == false) {
			 self.disableIconBar();
			 return false;
		     }
		 }	 
		 self.enableIconBar();
		 return true;
     },
     
     closeOtherItems: function(id) {
		 var self = this;	 
		 for(var i=0; i < self.itemStack.length; i++) {
		     if(self.itemStack[i].formValid == true && self.itemStack[i].opt.id != id) {
			 self.itemStack[i].hideForm();
		     }
		 }
     },
     
     
     updateStatus: function() {
		 var self = this;
		 
		 self.price = 0;
		 for(var i=0; i < self.itemStack.length; i++) {
		     if(self.itemStack[i].formValid == true) {
			 self.price += self.itemStack[i].giveMonthPrice();
		     }
		 }
		 
		 self.opt.canvas.find('.status').html(
		    '<div class="title">monatl. Ausgaben</div>'+
		    '<div class="price">'+self.price+' €</div>'
		 );
     },
     
     loadSavings: function(callback) {
    	  var self = this;    	  
    	  var data = {id: this.opt.id};
    	  
    	  $.ajax({
    		  type: "POST",
    		  url: this.opt.ajaxUrl,
    		  data: data
   		  }).done(function( result ) {
   			  self.loadJson(result);
   		  }).error(function() {
   			  try {callback();}catch(e){}
   		  }); 
     },
     
     save: function(callback) {
    	 var self = this; 
    	 var json = this.getJson();    	 
    	 var data = {id: this.opt.id, result: json, status: this.status};
    	 
    	 $.ajax({
    		 type: "POST",
    		 url: this.opt.ajaxUrl,
    		 data: data
		  }).done(function( result ) {
			  try {callback();}catch(e){}
		  }).error(function() {
			  try {callback();}catch(e){}
		  });    	 
     },
     
     getJson: function() {
		 var value = Array();	 
		 for(var i=0; i < this.itemStack.length; i++) {
		     var obj = {
			zone: '',
			classNames: '',
			iconHtml: '',
			opt: null
		     };
		     
		     obj.zone = '#'+this.itemStack[i].opt.canvas.parent().attr("id");
		     obj.classNames = this.itemStack[i].opt.canvas.attr('class');
		     obj.iconHtml = '<span class="'+this.itemStack[i].opt.canvas.find('span:first').attr('class')+'"><i></i></span>';
		     obj.opt = jQuery.extend({}, this.itemStack[i].opt);
		     obj.opt.canvas = null;
		     obj.opt.control = null;
		     value.push(obj);
		 }	 
		 
		 return JSON.stringify(value);
     },
     
     loadJson: function(str) {
		 //var str = [{"zone":"#zone4","classNames":"icon ui-draggable inzone small","iconHtml":"<span class=\"glyphicons print\"><i></i></span>","opt":{"canvas":null,"id":3,"type":"12","data":{"desc":"dasd asdas","price":204},"control":null}},{"zone":"#zone2","classNames":"icon ui-draggable inzone small","iconHtml":"<span class=\"glyphicons road\"><i></i></span>","opt":{"canvas":null,"id":4,"type":1,"data":{"desc":"fsdfsdfsd","price":34},"control":null}}];
		 var value = str;
		 
		 for(var i=0; i < value.length; i++) {
		     var node = $('<div class="'+value[i].classNames+'">'+value[i].iconHtml+'</div>');
		     value[i].opt.canvas = node;
		     value[i].opt.control = this;
		     $(value[i].zone).append(node);
		     var item = this.createItem(node, value[i].opt);
		 }
		 
		 this.initZoneDrags();
		 this.checkItems();
     }     
    
  });

})(jQuery);